# Created June 2002 by Mohammad Hassan; 
# routing generator class
Class QosrGen

proc qosr-usage { } {
puts {usage: routing [-<key 1> <value 1> ... -<key n> <value n>]

example options: 
-outfile1 f1 -outfile2 f2

WHILE ASSINING BANDWITH REQUIRED BY THE FLOWS A DEFAULT VALUE OF 5MB IS SET FOR ALL FLOWS.
IN THE tcl FILE GENERATED BY THE agent-gen-tcl AND THERE A GLOBAL ARRAY  CALLED gband IS DEFINED.
YOU HAVE TO STORE THE VALUE OF FLOW REQUIREMENT IN  THIS ARRAY("gband").     
  }
}



proc qosr { args } {
	set len [llength $args]

	if { $len } {
	    set key [lindex $args 0]
            if {$key == "-?" || $key == "--help" || $key == "-help" \
			|| $key == "-h" } {
			qosr-usage
			return
                }
	}

        if { [expr $len % 2] } {
                # if number is odd => error !
                puts "fewer number of arguments than needed in \"$args\""
                qosr-usage
		return
        }

	# check if the QosrGen type exists
	if { [catch {set rg [QosrGen info instances]}] } {
		puts "no class QosrGen"
		qosr-usage
		return
	}
	if { $rg == "" } {
		set rg [new QosrGen]
	}
	if { ![llength $args] } {
		$rg create
	} else {
		$rg create $args
	}
}

QosrGen instproc init { } {
	$self next
}

QosrGen instproc default_options { } {

	$self instvar opt_info

	set opt_info {
		# init file to -1, must be supplied by input
		outfile1 -1
                outfile2 -1
                # set default bandwith 50Mb

	}
	$self parse_opts
}
	
# are the parsing functions general enuf... ! chk
QosrGen instproc parse_opts { } {
	$self instvar opts opt_info

	while { $opt_info != ""} {
		# parse line by line
                if {![regexp "^\[^\n\]*\n" $opt_info line]} {
                        break  
                }
		# remove the parsed line
                regsub "^\[^\n\]*\n" $opt_info {} opt_info
		# remove leading spaces and tabs using trim
                set line [string trim $line]
		# skip comment lines beginning with #
                if {[regexp "^\[ \t\]*#" $line]} {
                        continue
                }
		# skip empty lines
                if {$line == ""} {
                        continue
                } elseif [regexp {^([^ ]+)[ ]+([^ ]+)$} $line dummy key value] {
                        set opts($key) $value
                } 
	}
}

QosrGen instproc parse_input { args } {
	# remove the list brackets from the args list
        set args [lindex $args 0]
        set len [llength $args]

	$self instvar opts

	for { set i 0 } { $i < $len } { incr i } {
		set key [lindex $args $i]
		regsub {^-} $key {} key
                if {![info exists opts($key)]} {
			puts stderr "unrecognized option $key"
			qosr-usage
			return -1
		}
		incr i
		# puts "changing $key from $opts($key) to [lindex $args $i]"
		set opts($key) [lindex $args $i]
	}
	# puts "end of parsing... "
	return 0
}

QosrGen instproc create { args } {
        # remove the list brackets from the args list
        set args [lindex $args 0]
        set len [llength $args]
        # puts "calling create with args $args, len $len"

	$self default_options

	if { $len } {
		if { [$self parse_input $args] == -1 } {
			return 
		}
	}
	# check that the filename is provided
	$self instvar opts
	if { $opts(outfile1) == -1 || $opts(outfile1) == -1 } {
	 puts {you must provide outfile name. use "routing -h" for help}
		return
	}
	$self create-qosr
}

QosrGen instproc create-qosr { } {
	# XXX leave out the checks to ns later.. !
	# this would allow extensibility to include other kinds of 
	# routing without having to modify the generator
	# if { [$self input-check] == -1 } {
	#	puts "There's an input error !! aborting"
	#	qosr-usage
	# 	return
	# }
	
	$self instvar opts

	set file1 $opts(outfile1)
        set file2 $opts(outfile2)

	$self generate-code $file1 $file2
}



QosrGen instproc GetNodes { type } {

         if {[catch {set tg [ScenGen getTG]}]} {
            puts stderr {Can't find topology generator..quiting!
                        Either run the topology generator first, or provide the total
                        number of nodes using the "totalnodes" option.
                        Use "agents -h" for more help.}
            exit
           }
         return [$tg getNodes $type]        

}
QosrGen instproc generate-code { file1 file2 } {
        $self instvar opts
	set f1 [open $file1 w]
        set f2 [open $file2 w]

	# puts "generate-code 
        puts $f1 "source qosr-source.tcl"        
        puts $f2 "source qosr-source.tcl"

	puts $f1 "proc setup-qosr1 \{ sim node baw \} \{ "
        puts $f2 "proc setup-qosr2 \{ sim node \} \{ " 
 
	puts $f1 "\t upvar \$sim ns"
        puts $f1 "\t upvar \$node no"

        puts $f2 "\t upvar \$sim ns"
        puts $f2 "\t upvar \$node no"


        puts $f1 "\t global totaltcp \n"
        puts $f1 "\t global gtcp \n"
        puts $f1 "\t global gsorc \n"
        puts $f1 "\t global gdst \n"
        puts $f1 "\t global gsrc \n"
        puts $f1 "\t global gfid \n"
        puts $f1 "\t global gstart \n"
        puts $f1 "\t global timescalled \n"
        puts $f1 "\t global gband \n"
      #  add-control

        puts $f2 "\t global totaltcp \n"
        puts $f2 "\t global gtcp \n"
        puts $f2 "\t global gsorc \n"
        puts $f2 "\t global gdst \n"
        puts $f2 "\t global gsrc \n"
        puts $f2 "\t global gfid \n"
        puts $f2 "\t global gstart \n"
        puts $f2 "\t global timescalled \n"
        puts $f2 "\t global gband \n"



       puts $f1 "\t foreach a \{"

        set alllinks [$self GetNodes "alllinks"]
        puts "hhhhhhhhhhhhhhh $alllinks"
        set alllinks [split $alllinks :]
        foreach pair $alllinks {
         set pairs [split $pair ?]
         set pair1 [lindex $pairs 0]
         set pair2 [lindex $pairs 1]
         set pair3 [lindex $pairs 2]
         puts $f1 "\t \{$pair1 $pair2 $pair3\}"         
        }
       puts $f1 "\t \} \{ "
       puts $f1 "\t if \{\$baw==0\} \{"
     #  puts $f1 "\t \t \[lindex \$a 2\]" 
       puts $f1 "\t \t \$ns add-control \[lindex \$a 0\] \[lindex \$a 1\] \[lindex \$a 2\]"
       puts $f1 "\t \} else \{"
       puts $f1 "\t \t \$ns add-control \[lindex \$a 0\] \[lindex \$a 1\] \$baw"
       puts $f1 "\t \}" 
        puts $f1 "\t \}"

puts $f1 "\}"

flush $f1
close $f1


       puts $f2 "\t set timescalled \[split \$timescalled :\]" 
       puts $f2 "\t set timescalled \[lreplace \$timescalled 0 0\]"
       puts $f2 "\t foreach index \$timescalled \{"
set myadd "\$no\(\$gsorc\(\$index\)\) create-session \$no\(\$gdst\(\$index\)\) \$gband\(\$index\) \$gfid\(\$index\) \$gtcp\(\$index\)"
set myadd_1 "\$ns at \[expr \$gstart\(\$index\)-0.0001\]"
set myadd "$myadd_1 \"$myadd\" \n"
       puts $f2 $myadd       
puts $f2 "\t \}"
         
puts $f2 "\}"
flush $f2
close $f2
}


