set topofile topo1.tcl
set agentfile agent1.tcl
set qosrfile1 qosr1.tcl
set qosrfile2 qosr2.tcl
set policyfile policy1.tcl

 source $topofile
 source $agentfile
 source $qosrfile1
 source $qosrfile2
 source $policyfile

ADC set bandwidth_ 0
ADC/Param set oresv_rate_ 0

 set ns [new Simulator]

# set up hierarchical routing (if needed) or any other address format
# $ns set-address-format hierarchical

# comment out the ns trace for now... it consumes a lot of mem
# set f [open out.tr w]
# $ns trace-all $f
 set nf [open out.nam w]
 $ns namtrace-all $nf

# have to call these before the topology is generated, as
# artifact of current ns !!!
# setup-mcastNaddr ns

# call the topology script

$ns src_rting 1

Node enable-module "QOSPF"

 set hier_flag 1

 if {$hier_flag} {
        create-hier-nodes ns node
        create-edges ns node 100Mb
 } else {
        create-nodes ns node
        set BW 100Mb
        create-edges ns node $BW
 }

setup-policy ns node

setup-qosr1 ns node 100Mb

# set routing
# create-routing ns


# call the agent script
$ns configure-qospf-nodes

generate-agents ns node

 setup-qosr2 ns node

   $ns at 2.90 "out-pol ns node"
 $ns at 3.0 "finish"

 proc finish {} {
        global ns nf; #f
        $ns flush-trace
        # close $f
        close $nf

        puts "running nam..."
        exec nam out.nam &
        exit 0
 }

$ns run


